/**
	$Id: OverviewPlotBean.java 4908 2009-04-28 12:47:33Z nicklas $

	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.plot;

/**
	A simple bean-like implementation of the {@link OverviewPlotAction}
	interface.

	@author Nicklas
	@version 2.12
	@base.modified $Date: 2009-04-28 14:47:33 +0200 (tis, 28 apr. 2009) $
*/
public class OverviewPlotBean
	implements OverviewPlotAction
{	
	
	private String id;
	private String title;
	private String description;
	private PlotGenerator[] generators;
	
	
	public OverviewPlotBean()
	{}

	/*
		From the OverviewPlotAction interface
		-------------------------------------
	*/
	@Override
	public String getId()
	{
		return id;
	}
	@Override
	public String getTitle()
	{
		return title;
	}
	@Override
	public String getDescription()
	{
		return description;
	}
	@Override
	public PlotGenerator[] getPlotGenerators()
	{
		return generators;
	}
	// -----------------------------------------

	public void setId(String id)
	{
		this.id = id;
	}

	public void setTitle(String title)
	{
		this.title = title;
	}

	public void setDescription(String description)
	{
		this.description = description;
	}

	public void setPlotGenerators(PlotGenerator[] generators)
	{
		this.generators = generators;
	}
	
}
