/**
	$Id $

	Copyright (C) 2016 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.startpage;


/**
	A simple bean-like implementation of the {@link StartPageAction}
	interface.
	
	@author nicklas
	@since 3.8
*/
public class StartPageBean 
	implements StartPageAction 
{

	private String id;
	private String name;
	private String description;
	private String url;
	
	public StartPageBean()
	{}
	
	/*
		From the StartPageAction interface
		----------------------------------
	*/
	@Override
	public String getId() 
	{
		return id;
	}

	@Override
	public String getName() 
	{
		return name;
	}

	@Override
	public String getDescription() 
	{
		return description;
	}

	@Override
	public String getUrl() 
	{
		return url;
	}
	// ---------------------------

	public void setId(String id) 
	{
		this.id = id;
	}

	public void setName(String name) 
	{
		this.name = name;
	}

	public void setDescription(String description) 
	{
		this.description = description;
	}

	public void setUrl(String url) 
	{
		this.url = url;
	}

}
