/*
	$Id: Controlled.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	This is the base tagging interface for items that needs special 
	attention by the {@link DbControl} object when {@link DbControl#commit()}
	is called. If an item implements this interface it is automatically
	placed in the internal commit queue of the <code>DbControl</code> object.
	Depending on which subinterfaces that are implemented (for example
	{@link Validatable} or {@link Transactional}) the <code>DbControl</code>
	takes certain actions.

	@author Nicklas
	@version 2.0
	@base.modified $Date: 2009-04-06 14:52:39 +0200 (mån, 06 apr. 2009) $
*/
public interface Controlled
{}
