
/**
	$Id: DisallowedValueException.java 4517 2008-09-11 20:11:02Z jari $

	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	Exception that is thrown when a value is not found among a set of allowed
	values, for example, when setting an annotation value.

	@author nicklas
	@version 2.4
	@base.modified $Date: 2008-09-11 22:11:02 +0200 (tors, 11 sep. 2008) $
 */
public class DisallowedValueException
	extends InvalidDataException
{
	/**
		
	*/
	private static final long serialVersionUID = 1332642295480924999L;

	/**
		Create a new <code>DisallowedValueException</code> object.
	*/
	public DisallowedValueException()
	{
		super("Disallowed value.");
	}

	/**
		Create a new <code>DisallowedValueException</code> exception.
	 	@param msg Message from the caller to throw with the exception.
	*/
	public DisallowedValueException(String msg)
	{
		super(msg);
	}
	
	/**
		Create a new <code>DisallowedValueException</code> object.
	
		@param field The name of the field or parameter that doesn't allow this
			value
		@param value The value that is not allowed
	*/
	public DisallowedValueException(String field, Object value)
	{
		super("Disallowed value. The value '"+value+"' is not allowed for '" + field + "'");
	}

}
