/**
	$Id: ShutdownSignalSender.java 5399 2010-09-02 12:09:15Z nicklas $

	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.signal;

/**
	A signal sender implementation that is used by the system when
	shutting down. If the handler supports the {@link Signal#SHUTDOWN}
	signal it is sent, otherwise the {@link Signal#ABORT}.
	
	@author Nicklas
	@since 2.16
	@base.modified $Date: 2010-09-02 14:09:15 +0200 (tors, 02 sep. 2010) $
*/
public class ShutdownSignalSender
	implements SignalSender
{

	public ShutdownSignalSender()
	{}

	/*
		From the SignalSender interface
		-------------------------------
	*/
	@Override
	public void sendTo(SignalHandler handler)
	{
		if (handler.supports(Signal.SHUTDOWN))
		{
			handler.handleSignal(Signal.SHUTDOWN);
		}
		else if (handler.supports(Signal.ABORT))
		{
			handler.handleSignal(Signal.ABORT);
		}
	}
	// -------------------------------------
	
	
}
