/**
	$Id: NodeCache.java 4768 2009-02-18 13:26:21Z nicklas $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.overview.cache;

import java.util.HashMap;
import java.util.Map;

import net.sf.basedb.util.overview.Node;

/**
	A cache implementation for nodes.

	@author Nicklas
	@version 2.10
	@base.modified $Date: 2009-02-18 14:26:21 +0100 (ons, 18 feb. 2009) $
*/
public class NodeCache<K>
{

	private Map<K, Node> cache;
	
	public NodeCache()
	{
		this.cache = new HashMap<K, Node>();
	}
	
	public Node getNode(K key)
	{
		return cache.get(key);
	}
	
	public void putNode(K key, Node node)
	{
		cache.put(key, node);
	}
	
}
