/**
	$Id: Transformer.java 5662 2011-06-20 11:55:13Z nicklas $

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.transform;

import net.sf.basedb.core.DbControl;

/**

	@author Nicklas
	@since 3.0
	@base.modified $Date: 2011-06-20 13:55:13 +0200 (mån, 20 juni 2011) $
 */
public interface Transformer<T, F>
{

	/**
		Transform the given object into another object.
		@param from The source object
		@return An instance of the destination class or null
	*/
	public T transform(DbControl dc, F from);
	
}
