<%-- $Id: not_logged_in.jsp 7680 2019-04-04 07:08:48Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	This page is used to catch NotLoggedInExceptions which are
	directed here via the exception.jsp page. NotLoggedInExceptions
	happen when a user tries to access a protected page without beeing
	logged in. Typically the exception is thrown from the method that
	retrieves the BaseControl object:

	BASE.getExistingBaseControl(pageContext);

	This page will display a new login form allowing the user
	to login again and continue with what he/she was doing.

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	isErrorPage="true"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getSessionControl(pageContext, true);
final String ID = sc.getId();
final String root = request.getContextPath()+"/";
final String redirect = Values.getString((String)request.getAttribute("redirect"));

try
{
	%>
	<base:page type="default" menu="exception" title="Not logged in">
	<base:head scripts="exception.js">
	<style>
	.default h1
	{
		position: inherit;
		height: auto;
		width: auto;
	}
	.popup h1
	{
		margin-left: 0.5em;
	}
	</style>
	</base:head>
	<base:body data-resize-if-popup="1">
	
		<table style="margin: auto; max-width: 600px; margin-top:5em; margin-bottom: 1em;">
		<tr>
		<td>
			<h1>Not logged in</h1>
			<div class="messagecontainer error" style="margin-top: 0.25em; padding: 1em; font-size: 120%;">
				You have been automatically logged out due to inactivity or because the 
				server has been restarted.
				You may log in again and continue your work but unsaved changes 
				may have been lost.
			</div>
		</td>
		</tr>
		</table>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="close" title="Close"/>
			<base:button id="gologin" image="login.png" title="Login again&hellip;" />
		</base:buttongroup>
				
	</base:body>
	</base:page>
	<%
}
finally
{}
%>
