<%-- $Id: edit_project.jsp 7696 2019-04-09 11:21:17Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PermissionTemplate"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.json.NameableConverter"
	import="net.sf.basedb.util.json.JsonUtil"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.EnumSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
private static final int READ_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.READ));
private static final int USE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.USE));
private static final int RESTRICTED_WRITE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.RESTRICTED_WRITE));
private static final int WRITE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.WRITE));
private static final int DELETE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.DELETE));
private static final int SET_OWNER_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.SET_OWNER));
private static final int SET_PERMISSION_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.SET_PERMISSION));

private String getPermissionString(Set<Permission> permissions)
{
	StringBuilder sb = new StringBuilder();
	sb.append(permissions.contains(Permission.READ) ? "R" : "-");
	sb.append(permissions.contains(Permission.USE) ? "U" : "-");
	sb.append(permissions.contains(Permission.RESTRICTED_WRITE) ? "A" : "-");
	sb.append(permissions.contains(Permission.WRITE) ? "W" : "-");
	sb.append(permissions.contains(Permission.DELETE) ? "D" : "-");
	sb.append(permissions.contains(Permission.SET_OWNER) ? "O" : "-");
	sb.append(permissions.contains(Permission.SET_PERMISSION) ? "P" : "-");
	return sb.toString();
}
private JSONObject createSection(JSONArray jsonSections, Item item, String name)
{
	JSONObject json = new JSONObject();
	json.put("itemType", item.name());
	json.put("name", name);
	json.put("items", new JSONArray());
	jsonSections.add(json);
	return json;
}
private void addItem(JSONArray jsonSections, JSONObject jsonItem, Item itemType)
{
	for (Object section : jsonSections)
	{
		JSONObject js = (JSONObject)section;
		if (itemType.name().equals(js.get("itemType")))
		{
			((JSONArray)js.get("items")).add(jsonItem);
			break;
		}
	}
}
%>
<%
final Item itemType = Item.PROJECT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Project project = null;
	
	// Query to retrieve child groups
	ItemQuery<Group> groupQuery = null;
	// Query to retrieve user members
	ItemQuery<User> userQuery = null;
	
	RawDataType currentRawDataType = null;
	boolean readCurrentPermissionTemplate = true;
	PermissionTemplate currentPermissionTemplate = null;

	List<PermissionTemplate> recentPermissionTemplates = cc.getRecent(dc, Item.PERMISSIONTEMPLATE);

	if (itemId == 0)
	{
		title = "Create project";
		cc.removeObject("item");
		currentPermissionTemplate = Base.getFirstMatching(dc, PermissionTemplate.getQuery(), "name", cc.getPropertyFilter("permissionTemplate.name"));
	}
	else
	{
		project = Project.getById(dc, itemId);
		project.checkPermission(Permission.WRITE);
		cc.setObject("item", project);
		title = "Edit project -- " + HTML.encodeTags(project.getName());
		currentRawDataType = project.getDefaultRawDataType();
		
		try
		{
			currentPermissionTemplate = project.getPermissionTemplate();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentPermissionTemplate = false;
		}
	
		groupQuery = project.getGroups();
		groupQuery.include(Include.ALL);
		groupQuery.order(Orders.asc(Hql.property("name")));
		userQuery = project.getUsers();
		userQuery.include(Include.ALL);
		userQuery.order(Orders.asc(Hql.property("name")));
	}
	
	JSONArray jsonMembers = new JSONArray();
	
	JSONObject jsonUsers = new JSONObject();
	jsonUsers.put("itemType", "USER");
	jsonUsers.put("name", "Users");
	jsonMembers.add(jsonUsers);
	final Project prj = project;
	if (userQuery != null)
	{
		jsonUsers.put("items", JsonUtil.toArray(userQuery.iterate(dc), 
			new NameableConverter<User>()
			{
				protected void setMore(JSONObject json, User user)
				{
					Set<Permission> permissions = prj.getPermissions(user);
					json.put("name", user.getName() + " [" + getPermissionString(permissions) + "]");
					json.put("value", PermissionUtil.getPermissionCode(permissions));
				}
			}
		));
	}
	
	JSONObject jsonGroups = new JSONObject();
	jsonGroups.put("itemType", "GROUP");
	jsonGroups.put("name", "Groups");
	jsonMembers.add(jsonGroups);
	if (groupQuery != null)
	{
		jsonGroups.put("items", JsonUtil.toArray(groupQuery.iterate(dc), 
			new NameableConverter<Group>()
			{
				protected void setMore(JSONObject json, Group group)
				{
					Set<Permission> permissions = prj.getPermissions(group);
					json.put("name", group.getName() + " [" + getPermissionString(permissions) + "]");
					json.put("value", PermissionUtil.getPermissionCode(permissions));
				}
			}
		));
	}

	JSONArray jsonDefaultItems = new JSONArray();
	JSONObject jsonPlatforms = createSection(jsonDefaultItems, Item.PLATFORM, "Platforms");
	JSONObject jsonVariants = createSection(jsonDefaultItems, Item.PLATFORMVARIANT, "Platform variants");
	JSONObject jsonArrayDesigns = createSection(jsonDefaultItems, Item.ARRAYDESIGN, "Array designs");
	JSONObject jsonProtocols = createSection(jsonDefaultItems, Item.PROTOCOL, "Protocols");
	JSONObject jsonHardware = createSection(jsonDefaultItems, Item.HARDWARE, "Hardware");
	JSONObject jsonSoftware = createSection(jsonDefaultItems, Item.SOFTWARE, "Software");
	

	if (project != null)
	{
		for (BasicItem defaultItem : project.getDefaultItems(dc))
		{
			String name = defaultItem instanceof Nameable ? ((Nameable)defaultItem).getName() : defaultItem.toString();
			if (defaultItem instanceof Subtypable)
			{
				ItemSubtype subtype = ((Subtypable)defaultItem).getItemSubtype();
				if (subtype != null) name += " (" + subtype.getName() + ")";
			}
			JSONObject jsonItem = new JSONObject();
			jsonItem.put("id", defaultItem.getId());
			jsonItem.put("name", name);
			addItem(jsonDefaultItems, jsonItem, defaultItem.getType());
		}
	}
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), project);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,linkitems-2.js,~projects.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>

		<div id="page-data" class="datacontainer"
			data-read="<%=READ_CODE%>"
			data-use="<%=USE_CODE%>"
			data-restricted-write="<%=RESTRICTED_WRITE_CODE%>"
			data-write="<%=WRITE_CODE%>"
			data-delete="<%=DELETE_CODE%>"
			data-set-owner="<%=SET_OWNER_CODE%>"
			data-set-permission="<%=SET_PERMISSION_CODE%>"
			data-share-to-everyone="<%=sc.hasSystemPermission(Permission.SHARE_TO_EVERYONE) ? 1 : 0 %>"
			data-everyone-id="<%=SystemItems.getId(Group.EVERYONE)%>"
			></div>
		
		<form action="index.jsp?ID=<%=ID%>" method="post" name="project">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="autoPermissions" value="<%=PermissionUtil.getPermissionCode(project == null ? EnumSet.range(Permission.READ, Permission.DELETE): project.getAutoPermission())%>">
	
		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=project != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Project" helpid="project.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=project == null ? "focus-select" : "focus" %>"  
					type="text" name="name" 
					value="<%=HTML.encodeTags(project == null ? Values.getString(cc.getPropertyValue("name"), "New project") : project.getName())%>" 
					maxlength="<%=Project.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="big">
				<th>Default permissions</th>
				<td>
					<base:select 
						id="permissiontemplate_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentPermissionTemplate%>"
						denied="<%=!readCurrentPermissionTemplate%>"
						recent="<%=recentPermissionTemplates%>"
						newitem="<%=project == null%>"
						unselectedtext="- select a template or specify below -"
					/>
				
					<input type="checkbox" id="autoRead" checked name="auto_read" 
						><label for="autoRead">Read</label><br>
					<input type="checkbox" id="autoUse" checked name="auto_use" 
						><label for="autoUse">Use</label><br>
					<input type="checkbox" id="autoRestrictedWrite" name="auto_restricted_write" 
						><label for="autoRestrictedWrite">Annotate</label><br>
					<input type="checkbox" id="autoWrite" name="auto_write" 
						><label for="autoWrite">Write</label><br>
					<input type="checkbox" id="autoDelete" name="auto_delete" 
						><label for="autoDelete">Delete</label><br>
					<input type="checkbox" id="autoSetOwner" name="auto_set_owner" 
						><label for="autoSetOwner">Set owner</label><br>
					<input type="checkbox" id="autoSetPermission" name="auto_set_permission" 
						><label for="autoSetPermission">Set permission</label><br>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="4" cols="40" name="description" id="description"
						><%=HTML.encodeTags(project == null ? cc.getPropertyValue("description") : project.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>

		<t:tab id="members" title="Members" helpid="project.edit.members">
		
		<table class="fullform bg-filled-50">
		<tr>
			<td class="padded" style="width: 50%;"><b>Members</b></td>
			<td class="padded" style="width: 30%;"><b>Permissions</b></td>
			<td></td>
		</tr>
		<tr class="dynamic">
			<td style="padding-left: 5px; padding-right: 5px;">
				<select name="members" id="members" 
					class="auto-init"
					data-auto-init="link-container"
					data-initial-items="<%=HTML.encodeTags(jsonMembers.toJSONString()) %>"
					size="13" multiple style="width: calc(100% - 10px);">
				</select>
			</td>
			<td>
				<input type="checkbox" id="read" checked name="read"><label for="read">Read</label><br>
				<input type="checkbox" id="use" checked name="use"><label for="use">Use</label><br>
				<input type="checkbox" id="restricted_write" name="restricted_write"><label for="restricted_write">Annotate</label><br>
				<input type="checkbox" id="write" name="write"><label for="write">Write</label><br>
				<input type="checkbox" id="delete" name="delete"><label for="delete">Delete</label><br>
				<input type="checkbox" id="setOwner" name="set_owner"><label for="setOwner">Set owner</label><br>
				<input type="checkbox" id="setPermission" name="set_permission"><label for="setPermission">Set permission</label><br>
			</td>
			<td>
				<base:buttongroup vertical="true" style="width: 12em;">
					<base:button 
						id="btnAddUsers"
						subclass="leftaligned"
						title="Add&nbsp;users&hellip;" 
						tooltip="Add users to this project"
					/>
					<base:button 
						id="btnAddGroups"
						subclass="leftaligned"
						title="Add&nbsp;groups&hellip;"  
						tooltip="Add groups to this project"
					/>
					<base:button 
						id="btnRemoveMembers"
						subclass="leftaligned auto-init"
						data-auto-init="remove-link"
						data-list-id="members"
						title="Remove" 
						tooltip="Remove the selected members from this project"
					/>
				</base:buttongroup>
			</td>
		</tr>
		</table>
		</t:tab>
		
		<t:tab id="defaults" title="Default items"  helpid="project.edit.defaults">
			<table class="fullform input100">
			<tr>
				<th>Raw data type</th>
				<td>
					<select name="rawdatatype">
					<option value="">- none -</option>
					<%
					for (RawDataType rdt : RawDataTypes.getSortedRawDataTypes(new RawDataTypes.NameComparator()))
					{
						if (rdt.isStoredInDb())
						{
							String selected = rdt.equals(currentRawDataType) ? "selected" : "";
							%>
							<option value="<%=rdt.getId()%>" <%=selected%>><%=HTML.encodeTags(rdt.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Default items</th>
				<td>
					<select name="defaultItems" id="defaultItems"
						class="auto-init"
						data-auto-init="link-container"
						data-initial-items="<%=HTML.encodeTags(jsonDefaultItems.toJSONString()) %>"
						size="13" multiple style="width: calc(100% - 10px);">
					</select>
				</td>
				<td style="width: 14em;">
					<base:buttongroup vertical="true" style="width: 12em;">
						<base:button 
							subclass="leftaligned auto-init"
							data-auto-init="add-link"
							data-list-id="defaultItems"
							data-item-type="PLATFORM"
							title="Add&nbsp;platforms&hellip;" 
							tooltip="Add default platforms to this project"
						/>
						<base:button 
							subclass="leftaligned auto-init"
							data-auto-init="add-link"
							data-list-id="defaultItems"
							data-item-type="PLATFORMVARIANT"
							title="Add&nbsp;variants&hellip;" 
							tooltip="Add default platform variants to this project"
						/>
						<base:button 
							subclass="leftaligned auto-init"
							data-auto-init="add-link"
							data-list-id="defaultItems"
							data-item-type="PROTOCOL"
							title="Add&nbsp;protocols&hellip;" 
							tooltip="Add default protocols to this project"
						/>
						<base:button 
							subclass="leftaligned auto-init"
							data-auto-init="add-link"
							data-list-id="defaultItems"
							data-item-type="HARDWARE"
							title="Add&nbsp;hardware&hellip;"  
							tooltip="Add default hardware to this project"
						/>
						<base:button 
							subclass="leftaligned auto-init"
							data-auto-init="add-link"
							data-list-id="defaultItems"
							data-item-type="SOFTWARE" 
							title="Add&nbsp;software&hellip;"  
							tooltip="Add default software to this project"
						/>
						<base:button 
							subclass="leftaligned auto-init"
							data-auto-init="add-link"
							data-list-id="defaultItems"
							data-item-type="ARRAYDESIGN"
							title="Add&nbsp;array&nbsp;designs&hellip;"  
							tooltip="Add default array designs to this project"
						/>
						<base:button 
							subclass="leftaligned auto-init"
							data-auto-init="remove-link"
							data-list-id="defaultItems"
							title="Remove" 
							tooltip="Remove the selected items from this project"
						/>
					</base:buttongroup>
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations" helpid="annotations.edit">
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
